DECLARE SUB PortAus (Datum!)
DECLARE FUNCTION PortEin ()
DECLARE FUNCTION AnalogEin! (Kanal!)
DECLARE SUB SystemReset ()
DECLARE SUB Init ()
DECLARE SUB Sende (Wert!)
DECLARE FUNCTION Empfang! ()

REM --------------- Hauptprogramm -------------------
Init
SystemReset
SCREEN 7
FOR n = 0 TO 3
  LINE (0, 25 + 40 * n)-(255, 25 + 40 * n)
  FOR i = 0 TO 5
    LINE (i * 50, 22 + 40 * n)-(i * 50, 25 + 40 * n)
  NEXT i
NEXT n
FOR n = 1 TO 4
  LOCATE 5 * n, 1
  PRINT "0    0.5    1     1.5    2    2.5"
NEXT n
DO
  a$ = INKEY$
  FOR n = 0 TO 3
    u = AnalogEin(n)
    LINE (0, 10 + n * 40)-(u, 20 + n * 40), 2, BF
    LINE (u + 1, 10 + n * 40)-(256, 20 + n * 40), 0, BF
  NEXT n
  IF a$ = " " THEN
    FOR n = 0 TO 3
      u = AnalogEin(n)
      LOCATE 3 + 5 * n, 35
      PRINT u / 100
    NEXT n
  END IF
  IF a$ = CHR$(27) THEN
    SCREEN 0
    END
  END IF
LOOP
SCREEN 0
END

REM -------------------------------------------------

FUNCTION AnalogEin! (Kanal!)
  Sende 7
  Sende (Kanal! + 1)
  AnalogEin! = Empfang
END FUNCTION

SUB PortAus (Datum!)
  Datum = (Datum AND 15) * 16 + 15
  Sende (11)
  Sende (Datum)
END SUB

FUNCTION PortEin ()
  Sende 12
  PortEin = INT(Empfang / 16)
END FUNCTION

FUNCTION Empfang!
  d$ = INPUT$(1, #1)
  Empfang! = ASC(d$)
END FUNCTION

SUB Init
  OPEN "COM2:9600,N,8,2,CS,DS" FOR RANDOM AS #1
  SystemReset
END SUB

SUB Sende (Wert!)
  PRINT #1, CHR$(Wert);
END SUB

SUB SystemReset
  FOR n = 1 TO 10
    Sende 0
  NEXT
END SUB
