//C-Routinen fr Borland C 3.1 nach Listing 29 im Buch
#include <stdio.h>
#include <dos.h>

#define PORT 0x2F8 		//COM 2
#define BYTE unsigned char
#define hi(x)	(x / 256)
#define lo(x)	(x & 255)

BYTE Puffer[6144];

void Oeffnen9600()
{int Wert;
 outportb(PORT+3,128);
 outportb(PORT+0, 12);
 outportb(PORT+1,  0);
 outportb(PORT+3,  7);
 outportb(PORT+4,  3);
 outportb(PORT+1,  0);
 Wert=inportb(PORT+0);
}

void Senden(BYTE Wert)
{while( !kbhit() && !(inportb(PORT+5) & 32) );
 outportb(PORT,Wert);
}

BYTE Empfang()
{int i=32000;
 while( i-- && !(inportb(PORT+5) & 1) );
 return inportb(PORT);
}

void SystemReset(void)
{int n;
 for(n=1;n<=10;n++)
 {Senden(6);
  delay(4);
 }
}

void Init4Kanal(int Laenge,int Zeit)
{SystemReset();
 Senden(1); delay(4);
 Senden(hi(Laenge));
 Senden(lo(Laenge));
 Senden(1);
 Senden(2);
 Senden(3);
 Senden(4);
 Senden(hi(Zeit-4));
 Senden(lo(Zeit-4));
 delay(4);
}

void Start(void)
{Senden(9);
}

void Einlesen(int Anzahl)
{int n,dummy;
 SystemReset();
 Senden(2); delay(4);
 for(n=1;n<=8;n++)
 {Senden(1);
  dummy=Empfang();
 }
 for(n=1;n<=Anzahl;n++)
 {Senden(1);
  Puffer[n-1]=Empfang();
 }
 Senden(0);
}

double Spannung(int Kanal)
{Senden(7);
 Senden(Kanal);
 return (double)Empfang()/100.0;
}

double Batteriespannung(void)
{return Spannung(4)*(820+470)/470;
}

void BusAus(BYTE Adresse,BYTE Datum)
{Senden(8);
 Senden(Adresse);
 Senden(Datum);
}

BYTE BusEin(BYTE Adresse)
{Senden(8);
 Senden(Adresse+128);
 return Empfang();
}

void PortAus(BYTE Datum)
{Senden(11);
 Senden(Datum);
}

BYTE PortEin(void)
{Senden(12);
 return Empfang();
}

main()
{Oeffnen9600();
 SystemReset();
 while (!kbhit())
  printf("A1:%4.2f V A2:%4.2f V A3:%4.2f V A4:%4.2f V UBat:%4.2f V %c",
	 Spannung(1),Spannung(2),Spannung(3),Spannung(4),
	 Batteriespannung(),13);
}